import React, { useState, useEffect } from "react";

import Icon from "@mdi/react";

import { mdiPlus } from "@mdi/js";
import { router, usePage, Head, Link } from "@inertiajs/react";

import { mdiChevronUp, mdiFacebook, mdiWhatsapp, mdiInstagram } from "@mdi/js";

export default function Header({ fixed = true }) {
    const { destinations, auth } = usePage().props;
    const [megamenuOpened, setMegamenuOpened] = useState(false);
    const [megamenuOpened0, setMegamenuOpened0] = useState(false);
    const [isBlurred, setIsBlurred] = useState(false);
    const [mobileOpen, setMobileOpen] = useState(false);
    const [showDropDown, setShowDropDown] = useState(false);
    const [showDest, setShowDest] = useState(false);

    useEffect(() => {
        const handleScroll = () => {
            const scrollY =
                window.scrollY || document.documentElement.scrollTop;
            // setIsBlurred(scrollY > window.innerHeight / 2);
            setIsBlurred(scrollY > 50);
        };

        window.addEventListener("scroll", handleScroll);

        return () => {
            window.removeEventListener("scroll", handleScroll);
        };
    }, []);

    const closeMegamenu = () => {
        setMegamenuOpened0(false);
        setMegamenuOpened(false);
    };
    const handleMouseEnter0 = () => {
        setMegamenuOpened0(true);
    };
    const handleMouseEnter = () => {
        setMegamenuOpened(true);
    };

    const handleMouseLeave = () => {
        setMegamenuOpened(false);
    };
    const handleMouseLeave0 = () => {
        setMegamenuOpened0(false);
    };

    const handleToggleMobileMenu = () => {
        setMobileOpen(!mobileOpen);
    };
    return (
        <>
            {/*========== PRELOADER STYLE START ==========*/}
            {/* <div
      class="flex items-center justify-center fixed w-full h-full z-50 bg-white preloader"
    >
      <div class="relative">
        <div
          class="h-30 w-30 rounded-full border-t-8 border-b-8 border-gray-200"
        ></div>
        <img
          src="/assets/images/logo-icon.png"
          alt="logo"
          class="absolute top-1/2 left-1/2 -translate-x-1/2 -translate-y-1/2 max-w-[50px]"
        />
        <div
          class="absolute top-0 left-0 h-30 w-30 rounded-full border-t-8 border-b-8 border-primary-1 animate-spin"
        ></div>
      </div>
    </div> */}
            {/* <header className="header-style"> */}
            <nav
                className={`${
                    fixed ? "fixed header-style" : "bg-gray-50 text-primary-500"
                } ${
                    isBlurred || (mobileOpen && !fixed)
                        ? "backdrop-blur-md fixed w-full  bg-opacity-80 bg-gray-50 dark:bg-muted-800 text-primary-500"
                        : ""
                } w-full z-50 text-white  transition-all duration-300 ease-in-out flex flex-col flex-shrink-0 divide-y ${
                    isBlurred || mobileOpen
                        ? "backdrop-blur-md bg-opacity-80 bg-gray-50 dark:bg-muted-800 text-primary-500"
                        : ""
                }`}
            >
                <div className="desktop-menu max-w-[1570px] mx-1 justify-between items-center md:flex hidden">
                    <div className="basis-[20%]">
                        <Link href="/contact-us" className="btn_primary__v1">
                            Help Me Plan
                            <svg
                                width={20}
                                height={20}
                                viewBox="0 0 20 20"
                                fill="none"
                                xmlns="http://www.w3.org/2000/svg"
                            >
                                <path
                                    d="M7.42505 16.5999L12.8584 11.1666C13.5 10.5249 13.5 9.4749 12.8584 8.83324L7.42505 3.3999"
                                    stroke="currentColor"
                                    strokeWidth="1.5"
                                    strokeMiterlimit={10}
                                    strokeLinecap="round"
                                    strokeLinejoin="round"
                                />
                            </svg>
                        </Link>
                    </div>
                    <div className="main-menu flex items-center uppercase">
                        <div className="menu-one">
                            <ul className="flex items-center nav-list ">
                                {/* dropdown */}
                                <li className="group/step-one">
                                    <Link
                                        href="/"
                                        className={`nav-link font-semibold  ${
                                            isBlurred || !fixed
                                                ? "text-black"
                                                : "text-white"
                                        }`}
                                    >
                                        Home
                                    </Link>
                                </li>
                                {/* dropdown */}
                                <li className="group/step-one">
                                    <Link
                                        href="/packages"
                                        className={`nav-link font-semibold ${
                                            isBlurred || !fixed
                                                ? "text-black"
                                                : "text-white"
                                        }`}
                                    >
                                        Packages
                                    </Link>
                                    {/* <ul className="nav-dropdown ">
                                        <li>
                                            <Link href="/packages">
                                                Package List
                                            </Link>
                                        </li>
                                    </ul> */}
                                </li>
                                {/* mega dropdown */}
                                <li className="group/mega-dropdown">
                                    <div
                                        className={`nav-link font-semibold cursor-pointer has-dropdownnn ${
                                            isBlurred || !fixed
                                                ? "text-black"
                                                : "text-white"
                                        }`}
                                    >
                                        Destinations▾
                                    </div>
                                    <div className="nav-mega-dropdown grid grid-cols-6 gap-x-1">
                                        <div className="col-span-4 border-r">
                                            <Link
                                                href="/destinations"
                                                className="py-2 flex items-center border-b border-stock-1 text-base text-dark-1 hover:text-primary-1 duration-200"
                                            >
                                                Browse All Destination
                                                <div className="max-w-[20px] ml-2">
                                                    <svg
                                                        className="group-hover/btn:translate-x-2 duration-200"
                                                        width={27}
                                                        height={14}
                                                        viewBox="0 0 27 14"
                                                        fill="none"
                                                        xmlns="http://www.w3.org/2000/svg"
                                                    >
                                                        <path
                                                            d="M0.217443 6.25H18.4827C18.6276 6.25 18.7001 6.30263 18.7001 6.40789V7.59211C18.7001 7.69737 18.6276 7.75 18.4827 7.75H0.217443C0.0724811 7.75 0 7.69737 0 7.59211V6.40789C0 6.30263 0.0724811 6.25 0.217443 6.25Z"
                                                            fill="currentColor"
                                                        />
                                                        <path
                                                            d="M20.7001 12.28L25.0467 7.9333C25.5601 7.41997 25.5601 6.57997 25.0467 6.06664L20.7001 1.71997"
                                                            stroke="currentColor"
                                                            strokeWidth="1.5"
                                                            strokeMiterlimit={
                                                                10
                                                            }
                                                            strokeLinecap="round"
                                                            strokeLinejoin="round"
                                                        />
                                                    </svg>
                                                </div>
                                            </Link>
                                            <ul className="grid grid-cols-3 mega-dropdown-links">
                                                {destinations.map(
                                                    (item, index) => {
                                                        return (
                                                            <li key={index}>
                                                                <Link
                                                                    href={`/destination/${
                                                                        item.id
                                                                    }/${item.name.replace(
                                                                        /\s+/g,
                                                                        "-"
                                                                    )}`}
                                                                >
                                                                    {item.name}
                                                                </Link>
                                                            </li>
                                                        );
                                                    }
                                                )}
                                            </ul>
                                        </div>
                                        <div className="col-span-2">
                                            <Link href="/destinations">
                                                <img
                                                    src="/assets/images/backgrounds/offer-banner.webp"
                                                    alt="offer-banner w-full"
                                                />
                                            </Link>
                                        </div>
                                    </div>
                                </li>
                            </ul>
                        </div>
                        <Link href="/" className="shrink-0 xl:mx- mx-07">
                            <img src="/logo.png" className="w-32" alt="logo" />{" "}
                        </Link>
                        <div className="menu-one">
                            <ul className="flex items-center nav-list">
                                {/* dropdown */}
                                <li className="group/step-one">
                                    <Link
                                        href="/about-us"
                                        className={`nav-link flex justify-center items-center font-semibold ${
                                            isBlurred || !fixed
                                                ? "text-black"
                                                : "text-white"
                                        }`}
                                    >
                                        About
                                    </Link>
                                    {/* <ul className="nav-dropdown">
                                        <li>
                                            <Link href="/about-us">
                                                About Us
                                            </Link>
                                        </li>
                                        <li>
                                            <Link href="destinations">
                                                Destinations
                                            </Link>
                                        </li>

                                      

                                        <li>
                                            <Link href="/register">
                                                Sign Up / Sign In
                                            </Link>
                                        </li>
                                       
                                    </ul> */}
                                </li>
                                {/* dropdown */}
                                <li className="group/step-one">
                                    <Link
                                        href="/blog"
                                        className={`nav-link font-semibold ${
                                            isBlurred || !fixed
                                                ? "text-black"
                                                : "text-white"
                                        }`}
                                    >
                                        News
                                    </Link>
                                    {/* <ul className="nav-dropdown">
                                        <li>
                                            <Link href="/blog">Blog Posts</Link>
                                        </li>
                                    </ul> */}
                                </li>

                                <li>
                                    <Link
                                        href="/contact-us"
                                        className={`nav-link flex justify-center items-center font-semibold ${
                                            isBlurred || !fixed
                                                ? "text-black"
                                                : "text-white"
                                        }`}
                                    >
                                        Contact
                                        {/* <Icon
                                            path={mdiChevronUp}
                                            size={0.7}
                                            className="text-primary-1 z-30 text-center hover:text-white"
                                        /> */}
                                    </Link>
                                </li>
                            </ul>
                        </div>
                        {/* <a
                            href="https://wa.me/+255764294329"
                            target="_blank"
                            // className={`nav-link font-semibold ${
                            //     isBlurred || !fixed
                            //         ? "text-black"
                            //         : "text-white"
                            // }`}
                        >
                            <Icon
                                path={mdiWhatsapp}
                                size={1.3}
                                className="text-green-500 text-center hover:text-white"
                            />
                        </a> */}
                    </div>
                    <div className="basis-[20%] flex justify-end ml-3 items-center">
                        {/* <Link
                            href="#"
                            className="text-dark-1 font-medium text-base text-white inline-flex items-center mr-5 hover:text-primary-1 duration-200"
                        >
                            <svg
                                width={24}
                                height={24}
                                viewBox="0 0 24 24"
                                fill="none"
                                xmlns="http://www.w3.org/2000/svg"
                            >
                                <rect width={24} height={24} />
                                <path
                                    d="M12 19C14.2091 19 16 17.2091 16 15C16 12.7909 14.2091 11 12 11C9.79086 11 8 12.7909 8 15C8 17.2091 9.79086 19 12 19Z"
                                    stroke="currentColor"
                                    strokeWidth="1.5"
                                    strokeMiterlimit={10}
                                    strokeLinecap="round"
                                    strokeLinejoin="round"
                                />
                                <path
                                    d="M12.25 13.75V14.68C12.25 15.03 12.07 15.36 11.76 15.54L11 16"
                                    stroke="currentColor"
                                    strokeWidth="1.5"
                                    strokeMiterlimit={10}
                                    strokeLinecap="round"
                                    strokeLinejoin="round"
                                />
                                <path
                                    d="M9.00007 22H15.0001C19.0201 22 19.7401 20.39 19.9501 18.43L20.7001 12.43C20.9701 9.99 20.2701 8 16.0001 8H8.00007C3.73007 8 3.03007 9.99 3.30007 12.43L4.05007 18.43C4.26007 20.39 4.98007 22 9.00007 22Z"
                                    stroke="currentColor"
                                    strokeWidth="1.5"
                                    strokeMiterlimit={10}
                                    strokeLinecap="round"
                                    strokeLinejoin="round"
                                />
                                <path
                                    d="M7.5 7.67001V6.70001C7.5 4.45001 9.31 2.24001 11.56 2.03001C14.24 1.77001 16.5 3.88001 16.5 6.51001V7.89001"
                                    stroke="currentColor"
                                    strokeWidth="1.5"
                                    strokeMiterlimit={10}
                                    strokeLinecap="round"
                                    strokeLinejoin="round"
                                />
                            </svg>
                            <span
                                className={`ml-1 font-semibold has-dropdownn ${
                                    isBlurred ? "text-black" : "text-white"
                                }`}
                            >
                                Cart (01)
                            </span>
                        </Link> */}
                        <Link
                            href="/dashboard"
                            className="shrink-0 inline-flex justify-center items-center bg-primary-1 rounded-full h-12 w-12 text-white hover:bg-primary-2 duration-300"
                        >
                            <svg
                                width={24}
                                height={24}
                                viewBox="0 0 24 24"
                                fill="none"
                                xmlns="http://www.w3.org/2000/svg"
                            >
                                <path
                                    d="M12.1601 10.87C12.0601 10.86 11.9401 10.86 11.8301 10.87C9.45006 10.79 7.56006 8.84 7.56006 6.44C7.56006 3.99 9.54006 2 12.0001 2C14.4501 2 16.4401 3.99 16.4401 6.44C16.4301 8.84 14.5401 10.79 12.1601 10.87Z"
                                    stroke="currentColor"
                                    strokeWidth="1.5"
                                    strokeLinecap="round"
                                    strokeLinejoin="round"
                                />
                                <path
                                    d="M7.15997 14.56C4.73997 16.18 4.73997 18.82 7.15997 20.43C9.90997 22.27 14.42 22.27 17.17 20.43C19.59 18.81 19.59 16.17 17.17 14.56C14.43 12.73 9.91997 12.73 7.15997 14.56Z"
                                    stroke="currentColor"
                                    strokeWidth="1.5"
                                    strokeLinecap="round"
                                    strokeLinejoin="round"
                                />
                            </svg>
                        </Link>
                    </div>
                </div>
                <div className="mobile-menu md:hidden flex flex-col justify-centerr items-centerr w-full relativee">
                    <div className="flex items-center justify-between w-full">
                        <Link href="/" className="shrink-0 max-w-[50pxl]">
                            <img
                                src="/logo.png"
                                // className="w-64 h-8"
                                className="w-56 h-24"
                                alt="logo"
                            />
                        </Link>
                        <div className="space-x-4 flex items-start">
                            <Link
                                href="#"
                                className="shrink-0 inline-flex justify-center items-center bg-primary-2 rounded-full h-10 w-10 text-white"
                            >
                                <svg
                                    width={24}
                                    height={24}
                                    viewBox="0 0 24 24"
                                    fill="none"
                                    xmlns="http://www.w3.org/2000/svg"
                                >
                                    <path
                                        d="M12.1601 10.87C12.0601 10.86 11.9401 10.86 11.8301 10.87C9.45006 10.79 7.56006 8.84 7.56006 6.44C7.56006 3.99 9.54006 2 12.0001 2C14.4501 2 16.4401 3.99 16.4401 6.44C16.4301 8.84 14.5401 10.79 12.1601 10.87Z"
                                        stroke="currentColor"
                                        strokeWidth="1.5"
                                        strokeLinecap="round"
                                        strokeLinejoin="round"
                                    />
                                    <path
                                        d="M7.15997 14.56C4.73997 16.18 4.73997 18.82 7.15997 20.43C9.90997 22.27 14.42 22.27 17.17 20.43C19.59 18.81 19.59 16.17 17.17 14.56C14.43 12.73 9.91997 12.73 7.15997 14.56Z"
                                        stroke="currentColor"
                                        strokeWidth="1.5"
                                        strokeLinecap="round"
                                        strokeLinejoin="round"
                                    />
                                </svg>
                            </Link>
                            <button
                                className={`flex relative justify-center items-center ml-auto w-10 h-10 z-30 focus:outline-none lg:hidden scale-90  ${
                                    isBlurred || mobileOpen
                                        ? "text-primary-500"
                                        : "text-primary-500"
                                }`}
                                onClick={handleToggleMobileMenu}
                            >
                                <div className="block top-1/2 left-6 w-4 -translate-x-1/2 -translate-y-1/2">
                                    <span
                                        className={`block absolute w-7 h-0.5  bg-primary-1 transition duration-500 ease-in-out ${
                                            mobileOpen
                                                ? "rotate-45"
                                                : "-translate-y-2"
                                        }`}
                                    ></span>
                                    <span
                                        className={`block absolute w-5 h-0.5  bg-primary-1 transition duration-500 ease-in-out ${
                                            mobileOpen ? "opacity-0" : ""
                                        }`}
                                    ></span>
                                    <span
                                        className={`block absolute w-7 h-0.5  bg-primary-1 gutransition duration-500 ease-in-out ${
                                            mobileOpen
                                                ? "-rotate-45"
                                                : "translate-y-2"
                                        }`}
                                    ></span>
                                </div>
                            </button>
                        </div>
                    </div>
                    <div
                        // className={`flex flex-col mt-3 mb-1 z-30 lg:flex-row lg:mx-auto lg:mt-0 lg:mb-0 lg:gap-x-4 ${
                        //     mobileOpen ? "flex" : "hidden"
                        // } md:flex menu flex-col md:flex-row items-center`}
                        className={`mobile-menu menu z-30 items-start flex justify-start  ${
                            mobileOpen ? "flex" : "hidden"
                        } `}
                    >
                        <ul>
                            <li className="group/step-one">
                                <Link
                                    href="/"
                                    className="nav-link  text-black nav-link font-semibold text-white-sm has-dropdownn"
                                >
                                    Home
                                </Link>
                            </li>{" "}
                            <li className="group/step-one">
                                <Link
                                    href="/packages"
                                    className="nav-link  text-black nav-link font-semibold text-white-sm"
                                >
                                    Packages
                                </Link>
                            </li>
                            <li
                                className="group/step-one"
                                onClick={() => setShowDest(!showDest)}
                            >
                                <Link
                                    href="/destinations"
                                    className="cursor-pointer text-black nav-link font-semibold text-white-sm has-dropdownn"
                                >
                                    Destinations▾
                                </Link>
                                {showDest && (
                                    <ul className="nav-dropdown-smm text-black">
                                        {destinations.map((item, index) => {
                                            return (
                                                <li key={index}>
                                                    <Link
                                                        href={`/destination/${
                                                            item.id
                                                        }/${item.name.replace(
                                                            /\s+/g,
                                                            "-"
                                                        )}`}
                                                    >
                                                        {item.name}
                                                    </Link>
                                                </li>
                                            );
                                        })}
                                    </ul>
                                )}
                            </li>
                            <li className="group/step-one">
                                <Link
                                    href="/blog"
                                    className="nav-link  text-black nav-link font-semibold text-white-sm has-dropdownn"
                                >
                                    Blog
                                </Link>
                                <ul className="nav-dropdown-sm">
                                    <li>
                                        <Link href="/blog">Blog Posts</Link>
                                    </li>
                                </ul>
                            </li>
                            <li
                                className="group/step-one text-black"
                                onClick={() => setShowDropDown(!showDropDown)}
                            >
                                <div className="cursor-pointer text-black nav-link font-semibold text-white-sm has-dropdownn">
                                    Pages
                                </div>
                                {showDropDown && (
                                    <ul className="nav-dropdown-smm">
                                        <li>
                                            <Link href="/about">About Us</Link>
                                        </li>
                                        <li>
                                            <Link href="/destination">
                                                Destinations
                                            </Link>
                                        </li>

                                        {/* <li>
                                            <Link href="/tour-guides">
                                                Guides
                                            </Link>
                                        </li>
                                        <li>
                                            <Link href="/gallery">Gallery</Link>
                                        </li>
                                        <li>
                                            <Link href="/faqs">FAQ</Link>
                                        </li> */}
                                        <li>
                                            <Link href="/register">
                                                Sign Up / Sign In
                                            </Link>
                                        </li>
                                    </ul>
                                )}
                            </li>
                            <li className="group/step-one">
                                <Link
                                    href="/contact-us"
                                    className="nav-link  text-black nav-link font-semibold text-white-sm"
                                >
                                    Contact
                                </Link>
                            </li>
                        </ul>
                    </div>
                </div>
            </nav>
        </>
    );
}
